# Fab-Manager's documentations

### User's manual
The following guide describes what you can do and how to use Fab-manager.
 - [Français](fr/guide_utilisation_fab_manager_v4.3.pdf)

### General documentation
Translators, contributors, developers and system administrators should start by reading this document.
- [Read first](../README.md)

### System administrator
The following guides are designed for the people that perform software maintenance.
- [Setup and update a production environment](production_readme.md)

- [Configuring the environment variables](environment.md)

- [Known issues with Fab-Manager](known-issues.md)

- [Advanced PostgreSQL usage](postgresql_readme.md)

- [Connecting a SSO using oAuth 2.0](sso_with_github.md)

- [Upgrade from Fab-manager v1.0](upgrade_v1.md)

#### Upgrades procedures
- [PostgreSQL](postgres_upgrade.md)
- [ElasticSearch](elastic_upgrade.md)

### Translator's documentation
If you intend to translate Fab-manager to a new, or an already supported language, you'll find here the information you need. 
- [Guide for translators](translation_readme.md)

### Developer's documentation
The following guides should help those who want to contribute to the code.
#### How to setup a development environment
- [With docker-compose](development_readme.md)

- [With vagrant](virtual-machine.md)

#### Externals
- [ElasticSearch mapping](elasticsearch.md)

- [Changing the database system](postgresql_readme.md#using-another-dbms)

#### Diagrams
- [Database diagram](database.svg)

- [Class diagram](class-diagram.svg)

- [Javascript dependencies](js-modules-dependencies.svg)

- [Ruby dependencies](gem-dependencies.svg)